unit junkwizu;

// Copyright  1999 by Ziff-Davis, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ActnList, Menus, hdObjs,
  ImgList;

type
  TTypeWiz = class(TForm)
    ActionList1       : TActionList;
      // main actions
        aHelp         : TAction;
        aBack         : TAction;
        aNext         : TAction;
      // dir actions
        aDirChange    : TAction;
        adirClear     : TAction;
      // delete-list actions
        aDelAdd       : TAction;
        aDelEdit      : TAction;
        adelRem       : TAction;
        adelClear     : TAction;
      // protect-list actions
        aproAdd       : TAction;
        aProEdit      : TAction;
        aproRem       : TAction;
        aproClear     : TAction;
    Images            : TImageList;
    Notebook1         : TNotebook;
      //Page   : Name
        ebName        : TEdit;
        gbClean       : TGroupBox;
          rbRecycle   : TRadioButton;
          rbBackup    : TRadioButton;
          rbDelete    : TRadioButton;
        cbEnabled     : TCheckBox;
      //Page   : Dirs
        lvDirs        : TListView;
        btndirChange  : TButton;
        btndirClear   : TButton;
      //Page: Dels
        btnDelAdd     : TButton;
        btnDelEdit    : TButton;
        btnDelRem     : TButton;
        btnDelClr     : TButton;
        lbDels        : TListBox;
        // date/age restrictions
        ckRstDate     : TCheckBox;
        rbDate        : TRadioButton;
        rbAge         : TRadioButton;
        cbDateType    : TComboBox;
        cbAgeDat1     : TComboBox;
        dpDateDat1    : TDateTimePicker;
        lblDateAnd    : TLabel;
        cbAgeDat2     : TComboBox;
        dpDateDat2    : TDateTimePicker;
        // size restrictions
        ckRstSize     : TCheckBox;
        cbSizeType    : TComboBox;
        ebSizeDat1    : TEdit;
        lblSizeAnd    : TLabel;
        ebSizeDat2    : TEdit;
        cbSizeUnits   : TComboBox;
      //Page: Prots
        btnPAdd       : TButton;
        btnPEdit      : TButton;
        btnPRem       : TButton;
        btnPClear     : TButton;
        lbProts       : TListBox;
      //Page: Summ
        reProps       : TRichEdit;
      //Page: Totl
        lblTypCount   : TLabel;
        lblTypDirs    : TLabel;
        lblTypDels    : TLabel;
        lblTypRes     : TLabel;
        lblTypProts   : TLabel;
        lblTypActual  : TLabel;
        lblTypSize    : TLabel;
        btnStop       : TButton;
        btnView       : TButton;
    Bevel1            : TBevel;
    pnlMain           : TPanel;
      btnHelp         : TButton;
      btnBack         : TButton;
      btnNext         : TButton;
      btnFinish       : TButton;
      btnCancel       : TButton;
    StatusBar1        : TStatusBar;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure aHelpExecute(Sender: TObject);
    procedure aBackExecute(Sender: TObject);
    procedure aNextExecute(Sender: TObject);
    procedure adirClearUpdate(Sender: TObject);
    procedure adirClearExecute(Sender: TObject);
    procedure adirChangeExecute(Sender: TObject);
    procedure aDelAddUpdate(Sender: TObject);
    procedure aDelAddExecute(Sender: TObject);
    procedure aDelEditExecute(Sender: TObject);
    procedure adelRemExecute(Sender: TObject);
    procedure adelClearExecute(Sender: TObject);
    procedure aproAddUpdate(Sender: TObject);
    procedure aproAddExecute(Sender: TObject);
    procedure aProEditExecute(Sender: TObject);
    procedure aproRemExecute(Sender: TObject);
    procedure aproClearExecute(Sender: TObject);
    procedure Notebook1PageChanged(Sender: TObject);
    procedure ebNameChange(Sender: TObject);
    procedure rbBackupClick(Sender: TObject);
    procedure ckRstDateClick(Sender: TObject);
    procedure rbDateClick(Sender: TObject);
    procedure cbDateTypeChange(Sender: TObject);
    procedure cbDateTypeDrawItem(Control: TWinControl;
      Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure cbAgeDatChange(Sender: TObject);
    procedure ckRstSizeClick(Sender: TObject);
    procedure cbSizeTypeChange(Sender: TObject);
    procedure ebSizeChange(Sender: TObject);
    procedure ebSizeKeyPress(Sender: TObject; var Key: Char);
    procedure cbSizeUnitsChange(Sender: TObject);
    procedure dpDateDatChange(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnViewClick(Sender: TObject);
    procedure pnlMainMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
  private
    { Private declarations }
    nameforAll : String;
    theObj     : TJunkFileObj;
    StopEvent  : THandle;
    TmpName    : String;
    TmpFile    : TextFile;
    function OkRestrictions : Boolean;
    function IsLocalDrives(TL : TListItem) : Boolean;
    procedure OneFile(const S : String; fSize : Int64);
    procedure ReptCounting(vSizDel : Int64; vNumDir, vNumDel,
      vNumRes, vNumProt : Integer);
    procedure DoneCounting(Sender : TObject);
    procedure EnDisButtons;
  public
    { Public declarations }
    procedure SetFromObj(TJ : TJunkFileObj; BinHasProb : Boolean);
    function GetFromObj : TJunkFileObj;
  end;

var
  TypeWiz: TTypeWiz;

implementation

uses shlobj, CommCtrl, activex, allfuncs, nufpicku, getspecu, mainu,
  getnameu, FoundU;

{$R *.DFM}
const
  nbpgName = 0;
  nbpgDirs = 1;
  nbpgDels = 2;
  nbpgProt = 3;
  nbpgSumm = 4;
  nbPgTotl = 5;
  Year4 : PChar = 'MM''/''dd''/''yyyy';

procedure TTypeWiz.FormCreate(Sender: TObject);
begin
  TheObj              := nil;
  Notebook1.PageIndex := nbPgName;
  rbDate.Checked      := True;
  GetPosFmEXEName(Application.ExeName, Self, True);
  NameForAll := Format('Local drives (%s)', [LocalDrives(':',',',
    IgnoreSubst)]);//1.01
  dpDateDat1.Date     := Now;
  dpDateDat2.Date     := Now;
  // Force 4-digit year even when computer's local
  // "short date" doesn't do so
  dpDateDat1.Perform(DTM_SETFORMAT, 0, Integer(Year4));
  dpDateDat2.Perform(DTM_SETFORMAT, 0, Integer(Year4));
  TmpName  := ChangeFileExt(Application.ExeName, '.$$$.TXT');
end;

procedure TTypeWiz.FormDestroy(Sender: TObject);
begin
  SetPosToEXEName(Application.ExeName, Self, True);
  IF Assigned(theObj) THEN theObj.Free;
  DeleteFile(TmpName);
end;

procedure TTypeWiz.FormResize(Sender: TObject);
// Without this, the text of the TRichEdit disappears upon
// vertical resizing?!
begin
  IF Notebook1.PageIndex = nbpgSumm THEN
    reProps.Refresh;
end;

procedure TTypeWiz.FormActivate(Sender: TObject);
begin
  ebName.SetFocus;
end;

procedure TTypeWiz.aHelpExecute(Sender: TObject);
begin
  Application.HelpContext(NoteBook1.PageIndex + 3);
end;

procedure TTypeWiz.aBackExecute(Sender: TObject);
begin
  IF NoteBook1.PageIndex = 0 THEN Exit;
  Notebook1.PageIndex := Notebook1.PageIndex - 1;
end;

procedure TTypeWiz.aNextExecute(Sender: TObject);
begin
  IF NoteBook1.PageIndex = nbPgTotl THEN Exit;
  Notebook1.PageIndex := Notebook1.PageIndex + 1;
end;

procedure TTypeWiz.adirClearUpdate(Sender: TObject);
begin
  IF NoteBook1.PageIndex <> nbpgDirs THEN Exit;
  adirClear.Enabled := (lvDirs.Items.Count > 0) AND
    (NOT IsLocalDrives(lvDirs.Items[0]));
end;

procedure TTypeWiz.adirClearExecute(Sender: TObject);
begin
  lvDirs.Items.Clear;
  lvDirs.Items.Add.Caption := NameForAll;
end;

procedure TTypeWiz.adirChangeExecute(Sender: TObject);
VAR
  TS : TStringList;
  N  : Integer;
begin
  WITH TNewPickForm.Create(Self) DO
  try
    TS := TStringList.Create;
    try
      FOR N := 0 TO lvDirs.Items.Count-1 DO
        WITH lvDirs.Items[N] DO
          IF NOT IsLocalDrives(lvDirs.Items[N]) THEN
            TS.AddObject(Caption, Data);
      LoadFromList(TS);
      IF ShowModal = idOK THEN
        begin
          SaveToList(TS);
          lvDirs.Items.Clear;
          FOR N := 0 TO TS.Count-1 DO
            WITH lvDirs.Items.Add DO
              begin
                Caption := TS[N];
                Data := TS.Objects[N];
                ImageIndex := Integer(Data);
                CASE ImageIndex OF
                  0 : SubItems.Add('Folder and subfolders');
                  1 : SubItems.Add('Folder only');
                  2 : SubItems.Add('Subfolders only');
                END;
              end;
        end;
    finally
      TS.Free;
    end;
  finally
    Free;
  end;
end;

procedure TTypeWiz.aDelAddUpdate(Sender: TObject);
begin
  adelRem.Enabled   := lbDels.ItemIndex >= 0;
  adelEdit.Enabled  := lbDels.ItemIndex >= 0;
  adelClear.Enabled := lbDels.Items.Count > 0;
end;

procedure TTypeWiz.aDelAddExecute(Sender: TObject);
begin
  WITH TSpecForm.Create(Self) DO
  try
    IF showModal = idOK THEN
      begin
        lbDels.items.Add(GetSpec);
        EnDisButtons;
      end;
  finally
    free;
  end;
end;

procedure TTypeWiz.aDelEditExecute(Sender: TObject);
begin
  WITH TSpecForm.Create(Self) DO
  try
    SetSpec(lbDels.Items[lbDels.ItemIndex]);
    IF showModal = idOK THEN
      begin
        lbDels.Items[lbDels.ItemIndex] := GetSpec;
        EnDisButtons;
      end;
  finally
    free;
  end;
end;

procedure TTypeWiz.adelRemExecute(Sender: TObject);
VAR idx : Integer;
begin
  idx := lbDels.ItemIndex;
  lbDels.Items.Delete(idx);
  IF idx > lbDels.Items.Count-1 THEN
    lbDels.ItemIndex := lbDels.Items.Count-1
  ELSE lbDels.ItemIndex := idx;
  EnDisButtons;
end;

procedure TTypeWiz.adelClearExecute(Sender: TObject);
begin
  lbDels.Clear;
  EnDisButtons;
end;

procedure TTypeWiz.ckRstDateClick(Sender: TObject);
begin
  IF (Sender AS TCheckBox).Checked THEN
    begin
      rbDate.Enabled     := True;
      rbAge.Enabled      := True;
      cbDateType.Enabled := True;
      cbAgeDat1.Enabled  := True;
      dpDateDat1.Enabled := True;
      cbAgeDat2.Enabled  := cbDateType.ItemIndex > 2;
      dpDateDat2.Enabled := cbDateType.ItemIndex > 2;
      lblDateAnd.Enabled := cbDateType.ItemIndex > 2;
    end
  ELSE
    begin
      rbDate.Enabled     := False;
      rbAge.Enabled      := False;
      cbDateType.Enabled := False;
      cbAgeDat1.Enabled  := False;
      dpDateDat1.Enabled := False;
      cbAgeDat2.Enabled  := False;
      dpDateDat2.Enabled := False;
      lblDateAnd.Enabled := False;
    end;
  EnDisButtons;
end;

procedure TTypeWiz.rbDateClick(Sender: TObject);
begin
  WITH Sender AS TRadioButton DO
    CASE Tag OF
      0 : begin //date
        cbDateType.Items.Text := 'exactly'#13#10'before'#13#10+
          'after'#13#10'between'#13#10'not between';
        dpDateDat1.BringToFront;
        dpDateDat2.BringToFront;
      end;
      1 : begin
        cbDateType.Items.Text := 'exactly'#13#10'older than'#13#10+
          'newer than'#13#10'between'#13#10'not between';
        cbAgeDat1.BringToFront;
        cbAgeDat2.BringToFront;
      end;
    END;
  EnDisButtons;
end;

procedure TTypeWiz.cbDateTypeChange(Sender: TObject);
begin
  dpDateDat2.Enabled := (Sender AS TComboBox).ItemIndex > 2;
  cbAgeDat2.Enabled  := dpDateDat2.Enabled;
  IF NOT cbAgeDat2.Enabled THEN
    cbAgeDat2.ItemIndex := -1;
  lblDateAnd.Enabled := dpDateDat2.Enabled;
  EnDisButtons;
end;

procedure TTypeWiz.cbDateTypeDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
VAR
  X, Y, N, R4, LineY         : Integer;
  MidlBox, LeftBox, RiteBox  : ARRAY[0..4] OF TPoint;
  LeftHaf, RiteHaf           : TPoint;
  LeftSeg, MidlSeg, RiteSeg  : TPoint;
  CV                         : TCanvas;
const
  cSiz = 4;

  procedure DotLine(A : TPoint);
  begin
    CV.Pen.Style := psDot;
    CV.PolyLine([Point(A.X, LineY), Point(A.Y, LineY)]);
    CV.Pen.Style := psSolid;
  end;

  procedure WidLine(A : TPoint);
  begin
    CV.Pen.Width := 2;
    CV.PolyLine([Point(A.X, LineY), Point(A.Y, LineY)]);
    CV.Pen.Width := 1;
  end;

  procedure OpenBox(A : ARRAY OF TPoint);
  begin
    CV.PolyLine(A);
  end;

  procedure FillBox(A : ARRAY OF TPoint);
  VAR Was : TColor;
  begin
    Was := CV.Brush.Color;
    CV.Brush.Color := clRed;
    CV.PolyGon(A);
    CV.Brush.Color := Was;
  end;

begin
  WITH Control AS TComboBox DO
    begin
      Canvas.TextRect(Rect, Rect.Left+2, Rect.Top, Items[Index]);
      Canvas.Pen.Color := clRed;
      CV         := Canvas;
      Y          := Rect.Bottom - (cSiz+1);
      X          := ((Rect.Right + Rect.Left - cSiz) DIV 2);
      MidlBox[0] := Point(X,      Y     );
      MidlBox[1] := Point(X+cSiz, Y     );
      MidlBox[2] := Point(X+cSiz, Y+cSiz);
      MidlBox[3] := Point(X,      Y+cSiz);
      MidlBox[4] := MidlBox[0];
      LeftBox    := MidlBox;
      RiteBox    := MidlBox;
      R4         := (Rect.Right-Rect.Left) DIV 4;
      FOR N      := 0 TO 4 DO Dec(LeftBox[N].X, R4);
      FOR N      := 0 TO 4 DO Inc(RiteBox[N].X, R4);
      LeftHaf    := Point(Rect.Left, X         );
      RiteHaf    := Point(X+cSiz,    Rect.Right);
      LeftSeg    := Point(Rect.Left, X-R4      );
      MidlSeg    := Point(X-R4+cSiz, X+R4      );
      RiteSeg    := Point(X+R4+cSiz, Rect.Right);
      LineY      := Y + (cSiz DIV 2);
      CASE Index OF
        0 : begin
          DotLine(LeftHaf);
          FillBox(MidlBox);
          DotLine(RiteHaf);
        end;
        1 : begin
          WidLine(LeftHaf);
          OpenBox(MidlBox);
          DotLine(RiteHaf);
        end;
        2 : begin
          DotLine(LeftHaf);
          FillBox(MidlBox);
          WidLine(RiteHaf);
        end;
        3 : begin
          DotLine(LeftSeg);
          FillBox(LeftBox);
          WidLine(MidlSeg);
          OpenBox(RiteBox);
          DotLine(RiteSeg);
        end;
        4 : begin
          WidLine(LeftSeg);
          OpenBox(LeftBox);
          DotLine(MidlSeg);
          FillBox(RiteBox);
          WidLine(RiteSeg);
        end;
      END;
    end;
end;

procedure TTypeWiz.cbAgeDatChange(Sender: TObject);
begin
  EnDisButtons;
end;

procedure TTypeWiz.dpDateDatChange(Sender: TObject);
begin
  EnDisButtons;
end;

procedure TTypeWiz.ckRstSizeClick(Sender: TObject);
begin
  IF (Sender AS TCheckBox).Checked THEN
    begin
      cbSizeType.Enabled  := True;
      ebSizeDat1.Enabled  := True;
      ebSizeDat2.Enabled  := cbSizeType.ItemIndex > 2;
      lblSizeAnd.Enabled  := cbSizeType.ItemIndex > 2;
      cbSizeUnits.Enabled := True;
    end
  ELSE
    begin
      cbSizeType.Enabled  := False;
      ebSizeDat1.Enabled  := False;
      ebSizeDat2.Enabled  := False;
      lblSizeAnd.Enabled  := False;
      cbSizeUnits.Enabled := False;
    end;
  EnDisButtons;
end;

procedure TTypeWiz.cbSizeTypeChange(Sender: TObject);
begin
  ebSizeDat2.Enabled := (Sender AS TComboBox).ItemIndex > 2;
  IF NOT ebSizeDat2.Enabled THEN
    ebSizeDat2.Text := '';
  lblSizeAnd.Enabled := ebSizeDat2.Enabled;
  EnDisButtons;
end;

procedure TTypeWiz.ebSizeChange(Sender: TObject);
VAR
  S : String;
  N : Integer;
begin
  S := (Sender AS TEdit).Text;
  FOR N := length(S) DOWNTO 1 DO
    CASE S[N] OF
      '0'..'9' : ; // OK
      ELSE Delete(S, N, 1);
    END;
  IF S <> (Sender AS TEdit).Text THEN
    begin
      (Sender AS TEdit).Text := S;
      (Sender AS TEdit).SelStart := length(S);
    end;
  EnDisButtons;
end;

procedure TTypeWiz.ebSizeKeyPress(Sender: TObject; var Key: Char);
begin
  CASE Key OF
    #0..#31, '0'..'9' : ;
    ELSE Key := #0;
  end;
end;

procedure TTypeWiz.cbSizeUnitsChange(Sender: TObject);
begin
  EnDisButtons;
end;

procedure TTypeWiz.aproAddUpdate(Sender: TObject);
begin
  aproRem.Enabled   := lbProts.ItemIndex >= 0;
  aproEdit.Enabled  := lbProts.ItemIndex >= 0;
  aproClear.Enabled := lbProts.Items.Count > 0;
end;

procedure TTypeWiz.aproAddExecute(Sender: TObject);
begin
  WITH TNameForm.Create(Self) DO
  try
    IF showModal = idOK THEN
      lbProts.items.Add(GetSpec);
  finally
    free;
  end;
end;

procedure TTypeWiz.aProEditExecute(Sender: TObject);
begin
  WITH TNameForm.Create(Self) DO
  try
    SetSpec(lbProts.Items[lbProts.ItemIndex]);
    IF showModal = idOK THEN
      lbProts.Items[lbProts.ItemIndex] := GetSpec;
  finally
    free;
  end;
end;

procedure TTypeWiz.aproRemExecute(Sender: TObject);
VAR idx : Integer;
begin
  idx := lbProts.ItemIndex;
  lbProts.Items.Delete(idx);
  IF idx > lbProts.Items.Count-1 THEN
    lbProts.ItemIndex := lbProts.Items.Count-1
  ELSE lbProts.ItemIndex := idx;
  EnDisButtons;
end;

procedure TTypeWiz.aproClearExecute(Sender: TObject);
begin
  lbProts.Clear;
end;

procedure TTypeWiz.btnStopClick(Sender: TObject);
begin
  SetEvent(StopEvent);
  btnStop.Enabled := False;
end;

procedure TTypeWiz.btnViewClick(Sender: TObject);
begin
  WITH TFoundForm.Create(Self) DO
  try
    SetData(tmpName, ebName.Text);
    ShowModal;
  finally
    Free;
  end;
end;

procedure TTypeWiz.Notebook1PageChanged(Sender: TObject);
begin
  EnDisButtons;
  CASE Notebook1.PageIndex OF
    nbpgSumm : begin
      btnNext.Default      := True;
      btnFinish.Default    := False;
      IF Assigned(theObj) THEN
      IF Assigned(theObj) THEN
        begin
          theObj.Free;
          theObj := nil;
        end;
      GetFromObj.REDisplay(reProps);
    end;
    nbpgTotl : begin
      // Count the matching files
      btnStop.Enabled      := True;
      btnView.Enabled      := False;
      Screen.Cursor        := crAppStart;
      btnCancel.Enabled    := False;
      btnNext.Default      := False;
      btnFinish.Default    := True;
      lblTypCount.Caption  := Format('Counting files for "%s"',
        [theObj.typName]);
      lblTypDirs.Caption   := 'One moment please...';
      lblTypDels.Caption   := '';
      lblTypRes.Caption    := '';
      lblTypProts.Caption  := '';
      lblTypActual.Caption := '';
      lblTypSize.Caption   := '';
      StopEvent := CreateEvent(nil, True, False,
        'PC Magazine HDValet Stop Event');
      AssignFile(TmpFile, TmpName);
      Rewrite(TmpFile);
      GetFromObj.ActOnFiles(OneFile, ReptCounting, DoneCounting,
        StopEvent, ExtractFileDir(Application.ExeName));
    end;
  end;
end;

procedure TTypeWiz.ebNameChange(Sender: TObject);
begin
  EnDisButtons;
end;

procedure TTypeWiz.rbBackupClick(Sender: TObject);
begin
  // It's disable if there's a bin problem and the bin is selected
  cbEnabled.Enabled := True;
end;

procedure TTypeWiz.pnlMainMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This enables flyover hints for disabled controls
VAR
  P : TPoint;
  N : Integer;
begin
  P := Point(X,Y);
  WITH Sender AS TWinControl DO
    begin
      Hint := '';
      FOR N := 0 TO ControlCount-1 DO
        IF Controls[N] IS TWinControl THEN
          IF PtInRect(TWinControl(Controls[N]).BoundsRect, P) THEN
            Hint := TWinControl(Controls[N]).Hint + ' (disabled)';
      IF Hint = '' THEN
        Application.CancelHint;
    end;
end;

function TTypeWiz.OkRestrictions: Boolean;
begin
  // Do nothing if we're not on the restrictions page
  IF NoteBook1.PageIndex = nbpgDels THEN
    begin
      // If any problem, just Exit before setting to True
      Result := False;
      IF ckRstDate.Checked THEN
        begin
          // If no date-type chosen...
          IF cbDateType.ItemIndex < 0 THEN Exit;
          IF rbDate.Checked THEN
            begin
              // If between-type and dates are equal
              IF (cbDateType.ItemIndex > 2) AND
                (dpDateDat1.Date = dpDateDat2.Date) THEN Exit;
            end
          ELSE IF rbAge.Checked THEN
            begin
              // If first age not selected...
              IF cbAgeDat1.ItemIndex < 0 THEN Exit;
              // If between-type and second age not selected...
              IF (cbDateType.ItemIndex > 2) AND
                 (cbAgeDat2.ItemIndex < 0) THEN Exit;
              // If between-type and ages are equal
              IF (cbDateType.ItemIndex > 2) AND
               (cbAgeDat2.ItemIndex = cbAgeDat1.ItemIndex) THEN Exit;
            end
          ELSE Exit;
        end;
      IF ckRstSize.Checked THEN
        begin
          // If no size type chosen
          IF cbSizeType.ItemIndex < 0 THEN Exit;
          // If no units specified
          IF cbSizeUnits.ItemIndex < 0 THEN Exit;
          // If no first size number
          IF StrToIntDef(ebSizeDat1.Text, -1) < 0 THEN Exit;
          // If between-type and no second size number
          IF (cbSizeType.ItemIndex > 2) AND
             (StrToIntDef(ebSizeDat2.Text, -1) < 0) THEN Exit;
          // If between-type and sizes are equal
          IF (cbSizeType.ItemIndex > 2) AND
             (ebSizeDat2.Text = ebSizeDat1.Text) THEN Exit;
        end;
    end;
  Result := True;
end;

function TTypeWiz.IsLocalDrives(TL : TListItem) : Boolean;
begin
  Result := Pos('Local drives (', TL.Caption) = 1;
end;

procedure TTypeWiz.ReptCounting(vSizDel : Int64; vNumDir, vNumDel,
  vNumRes, vNumProt : Integer);
const
  t1 : ARRAY[Boolean] OF String = ('s were', ' was');
  t2 : ARRAY[Boolean] OF String = ('s', '');
  t3 : ARRAY[Boolean] OF String = ('These files', 'This file');
  t4 : ARRAY[Boolean] OF String = ('do', 'does');
  t5 : ARRAY[Boolean] OF String = ('occupy', 'occupies');
VAR
  ActualDel : Integer;
begin
  lblTypDirs.Caption  := Format('%d folder%s searched'#13#10,
    [vNumDir, t1[vNumDir=1]]);

  IF vNumDel = 0 THEN
    lblTypDels.Caption := 'No files matched the junk file '+
     'specifications'
  ELSE
    begin
      lblTypDels.Caption := Format('%d file%s matched the junk file '+
        'specifications'#13#10, [vNumDel, t2[vNumDel=1]]);
      lblTypRes.Caption := Format('%d file%s did not meet the date or size '+
        'restrictions'#13#10, [vNumRes, t2[vNumRes=1]]);
      lblTypProts.Caption := Format('%d file%s protected by the protect file '+
        'specifications'#13#10#13#10, [vNumProt, t1[vNumProt=1]]);
      ActualDel := vNumDel - vNumRes - vNumProt;
      IF ActualDel < 0 THEN ActualDel := 0;
      lblTypActual.Caption := Format('%d file%s would be processed',
        [ActualDel, t2[ActualDel=1]]);
      btnView.Enabled   := ActualDel > 0;
      IF ActualDel > 0 THEN
        begin
          IF vSizDel = 0 THEN
            lblTypSize.Caption := Format('%s %s not occupy any disk space',
              [t3[ActualDel=1], t4[ActualDel=1]])
          ELSE
            lblTypSize.Caption := Format('%s %s %s  of disk space.',
              [t3[ActualDel=1], t5[ActualDel=1],
              StringForBytes(vSizDel)]);
        end;
    end;
end;

procedure TTypeWiz.DoneCounting(Sender: TObject);
begin
  WITH Sender AS TJunkDelThread DO
    IF WasStopped THEN
      begin
        lblTypCount.Caption := 'Operation stopped by user';
        lblTypDirs.Caption := '';
      end;
  CloseFile(TmpFile);
  ResetEvent(StopEvent);
  CloseHandle(StopEvent);
  Screen.Cursor     := crDefault;
  btnFinish.Enabled := True;
  btnNext.Enabled   := False;
  btnBack.Enabled   := True;
  btnCancel.Enabled := True;
  btnStop.Enabled   := False;
end;

procedure TTypeWiz.EnDisButtons;
begin
  btnBack.Enabled := (Notebook1.PageIndex <> nbPgName) AND
    (Notebook1.PageIndex <> nbPgTotl);
  btnFinish.Enabled := (ebName.Text <>'') AND OKRestrictions AND
    (lbDels.Items.Count > 0) AND (Notebook1.PageIndex <> nbPgTotl);
  btnNext.Enabled := Notebook1.PageIndex <> nbPgTotl;
  CASE Notebook1.PageIndex OF
    nbpgName : btnNext.Enabled   := ebName.Text <>'';
    nbpgDels : btnNext.Enabled   := (lbDels.Items.Count > 0) AND
        OKRestrictions;
  end;
end;

procedure TTypeWiz.SetFromObj(TJ: TJunkFileObj; BinHasProb : Boolean);
VAR N : Integer;
begin
  IF BinHasProb THEN
    begin
      rbRecycle.Enabled := False;
      cbEnabled.Enabled  := NOT rbRecycle.Checked;
    end;
  WITH TJ DO
    begin
      ebName.text       := TypName;
      cbEnabled.Checked := IsChecked;
      CASE BackType OF
        cuHolding : rbBackup.Checked := True;
        cuDelete  : rbDelete.Checked := True;
        ELSE        rbRecycle.Checked := True;
      end;
      FOR N := 0 TO Dirs.Count-1 DO
        IF Trim(Dirs[N]) <> '' THEN
          WITH lvDirs.Items.Add DO
            begin
              Caption    := Dirs[N];
              Data       := Dirs.Objects[N];
              ImageIndex := Integer(Data);
              CASE ImageIndex OF
                0 : SubItems.Add('Folder and subfolders');
                1 : SubItems.Add('Folder only');
                2 : SubItems.Add('Subfolders only');
              END;
            end;
      lbDels.Items.Assign(Deletes);
      lbProts.Items.Assign(Prots);
      IF DateRestrict THEN
        begin
          ckRstDate.Checked    := True;
          ckRstDateClick(ckRstDate);
          rbDate.Checked       := True;
          rbDateClick(rbDate);
          cbDateType.ItemIndex := DateRestrictType;
          cbDateTypeChange(cbDateType);
          dpDateDat1.Date      := DateData1;
          dpDateDat2.Date      := DateData2;
        end;
      IF AgeRestrict THEN
        begin
          ckRstDate.Checked    := True;
          ckRstDateClick(ckRstDate);
          rbAge.Checked        := True;
          rbDateClick(rbAge);
          cbDateType.ItemIndex := AgeRestrictType;
          cbDateTypeChange(cbDateType);
          cbAgeDat1.ItemIndex  := AgeData1;
          cbAgeDat2.ItemIndex  := AgeData2;
        end;
      IF SizeRestrict THEN
        begin
          ckRstSize.Checked     := True;
          ckRstSizeClick(ckRstSize);
          cbSizeType.ItemIndex  := SizeRestrictType;
          cbSizeTypeChange(cbSizeType);
          ebSizeDat1.Text       := IntToStr(SizeData1);
          ebSizeDat2.Text       := IntToStr(SizeData2);
          cbSizeUnits.ItemIndex := SizeUnit;
        end;
    end;
  NoteBook1PageChanged(NoteBook1);
  IF lvDirs.Items.Count = 0 THEN
    lvDirs.Items.Add.Caption := NameForAll;
end;

function TTypeWiz.GetFromObj: TJunkFileObj;
VAR
  TempS    : TStringList;
  N, bType : Integer;
begin
  IF NOT Assigned(theObj) THEN
    begin
      TempS := TStringList.Create;
      IF (lvDirs.Items.Count > 1) OR
         (NOT IsLocalDrives(lvDirs.Items[0])) THEN
        FOR N := 0 TO lvDirs.Items.Count-1 DO
          WITH lvDirs.Items[N] DO
            TempS.AddObject(Caption, Data);
      IF Assigned(theObj) THEN
        theObj.Free;
      IF rbRecycle.Checked THEN bType := cuRecycle
      ELSE IF rbDelete.Checked THEN bType := cuDelete
      ELSE bType := cuHolding;
      theObj := TJunkFileObj.Create(
        ebName.text,                          // vName
        cbEnabled.Checked,                    // vChecked
        bType,                                // vBacktype
        TempS,                                // vDirs
        lbDels.Items,                         // vDeletes
        lbProts.Items,                        // vProts
        ckRstDate.Checked AND rbDate.Checked, // vDateRestrict
        cbDateType.ItemIndex,                 // vDateRestrictType
        dpDateDat1.Date,                      // vDateData1
        dpDateDat2.Date,                      // vDateData2
        ckRstDate.Checked AND rbAge.Checked,  // vAgeRestrict
        cbDateType.ItemIndex,                 // vAgeRestrictType,
        cbAgeDat1.ItemIndex,                  // vAgeData1
        cbAgeDat2.ItemIndex,                  // vAgeData2
        ckRstSize.Checked,                    // vSizeRestrict
        cbSizeType.ItemIndex,                 // vSizeRestrictType
        StrToIntDef(ebSizeDat1.Text, 0),      // vSizeData1
        StrToIntDef(ebSizeDat2.Text, 0),      // vSizeData2
        cbSizeUnits.ItemIndex);               // vSizeUnit
      TempS.Free;
    end;
  Result := theObj;
end;

procedure TTypeWiz.OneFile(const S: String; fSize: Int64);
begin
  WriteLn(TmpFile, S);
end;


end.

